deferred class TEST_DYNAMIC_LIST

feature

	tested: DYNAMIC_LIST [STRING] is
		deferred
		end
	
	other_list: like tested

	make_tested is
		deferred
		ensure
			tested /= Void
		end

	make_other is
		deferred
		ensure
			other_list /= Void
		end

	testit is
		do
			make_tested
			test_extending
			test_traversing
			test_merging
			test_removing
		end

	test_extending is
		do
			print ("--- Test extending %N")
			tested.put_front ("foo")
			tested.extend ("one")
			tested.extend ("two")
			tested.extend ("three")
			tested.extend ("four")
			print ("Done. count=")
			print (tested.count)
			print ("%N")
		end

	test_traversing is
		do
			print ("--- Test traversing %N")
			from
				print ("Forward: %N")
				tested.start
			until
				tested.off
			loop
				print (tested.item)
				print ("%N")
				tested.forth
			end

			from
				print ("Backward:%N")
				tested.finish
			until
				tested.off
			loop
				print (tested.item)
				print ("%N")
				tested.back
			end
			print ("OK%N")
		end

	test_merging is
		do
			print ("--- Test merging%N")
			make_other
			other_list.extend ("other1")
			other_list.extend ("other2")
			other_list.extend ("other3")
			tested.start
			tested.forth
			tested.merge_left (other_list)
			print_list 
		end

	test_removing is
		do
			print ("--- Test removing%N")
		end

	print_list is
		do
			print ("Items in list: ")
			print (tested.count)
			print ("%N")
			from tested.start
			until tested.off
			loop
				print (tested.item) 
				print ("%N")
				tested.forth
			end
		end
end
